/*
 * 쐬: 2003/12/07
 *
 */
package com.muimi.pt;

import java.lang.reflect.InvocationHandler;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.ui.views.properties.IPropertySource;

/**
 * @author miya
 *
 */
public class AdapterProxy implements InvocationHandler {

	private Object real;


	public static Object[] newArrayInstance(Object[] array){
		//System.out.println(Arrays.asList(array));

		for(int i=0; i<array.length; i++){
			array[i] = newInstance(array[i]);
		}
		return array;
	}


	/**
	 * IAdaptableC^[tFCXǉvLVIuWFNgԂB
	 * @param obj
	 * @return
	 */
	public static Object newInstance(Object obj) {

		//String͖
		if(obj.getClass() == String.class){
			return obj;
		}
		//IAdaptableł΁AvLVȂ
		if(IAdaptable.class.isAssignableFrom(obj.getClass())){
			return obj;
		}
		

		Class[] interfaces = obj.getClass().getInterfaces();
		Class[] proxyInterfaces = new Class[interfaces.length+1];
		System.arraycopy(interfaces, 0, proxyInterfaces, 0, interfaces.length);
		proxyInterfaces[proxyInterfaces.length-1] = IAdaptable.class;

		try{
			return java.lang.reflect.Proxy.newProxyInstance(
				obj.getClass().getClassLoader(),
				proxyInterfaces,
				new AdapterProxy(obj));
		}catch(Exception e){
			e.printStackTrace();
			return obj;
		}
		
	}

	private AdapterProxy(Object obj) {
		this.real = obj;
	}

	public Object invoke(Object proxy, Method m, Object[] args)
		throws Throwable {
		Object result;
		try {
			//System.out.println(m.getName());
			if(m.getName().equals("getAdapter")){
				if(args[0] == IPropertySource.class){
					return new ReflectionPropertySource(real);//pass real class
				}else{
					return null;
				}
			}
			
			result = m.invoke(real, args);

		} catch (InvocationTargetException e) {
			throw e.getTargetException();

		} catch (Exception e) {
			e.printStackTrace();
			throw new RuntimeException(
				"unexpected invocation exception: " + e.getMessage());

		} finally {

		}
		return result;
	}


//	public static void main(String[] args){
//		IAdaptable a = new B();
//		if( IAdaptable.class.isAssignableFrom(a.getClass()) ){
//			System.out.println("YES");
//		}else{
//			System.out.println("NO");
//		}
//	}

}
