/*
 * 쐬: 2003/12/07
 *
 */
package com.muimi.pt;

import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.eclipse.ui.views.properties.IPropertyDescriptor;
import org.eclipse.ui.views.properties.IPropertySource;
import org.eclipse.ui.views.properties.TextPropertyDescriptor;

/**
 * @author miya
 */
public class ReflectionPropertySource implements IPropertySource{

	private Object real;


	private Map methodMap = new HashMap();
	private IPropertyDescriptor[] descs;



	public ReflectionPropertySource(Object o){
		this.real = o;
	}


	public Object getEditableValue() {
		return null;
	}


	public IPropertyDescriptor[] getPropertyDescriptors() {
		if(descs == null){
			descs = createPropertyDescriptors();
		}
		return descs;
	}

	private IPropertyDescriptor[] createPropertyDescriptors() {
		Method[] methods = real.getClass().getMethods();
		List list = new ArrayList();
		methodMap = new HashMap();
		
		for(int i=0 ; i<methods.length; i++){
			Method method = methods[i];
			if(method.getName().startsWith("get") 
				&& method.getParameterTypes().length == 0){
				String id = method.getName();
				String label = getPropertyLabel(method);
				
				IPropertyDescriptor desc = new TextPropertyDescriptor(					
					id,
					label
				);
				list.add(desc);
				methodMap.put(id, method);
			}
		}
		
		return (IPropertyDescriptor[])list.toArray(new IPropertyDescriptor[0]);
	}
	
	private String getPropertyLabel(Method method){
		String name = method.getName();
		return name.substring("get".length());
	}
	




	public Object getPropertyValue(Object id) {
		Method method = (Method) methodMap.get(id);
		
		try {
			Object result = method.invoke(real, new Object[0]);
			//lStringɂĂ킽BPropertySheetAssertBsB
			if(result != null){
				return result.toString();
			}else{
				return "";
			}
		} catch (Exception e) {
			e.printStackTrace();
			throw new IllegalStateException(e.toString());
		} 
	}


	


	public boolean isPropertySet(Object id) {
		return false;
	}


	public void resetPropertyValue(Object id) {
	}


	public void setPropertyValue(Object id, Object value) {
	}

}
